remove kinsis / unused input settings
[distro-setup] / conflink
index c385ca04e8e7c9738edaa7be5b480bb25ddef05d..38aacf02ac885a8a8c2ff0da27043c007373f457 100755 (executable)
--- a/conflink
+++ b/conflink
@@ -1,24 +1,25 @@
-#!/bin/bash -l
+#!/bin/bash
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+source /a/bin/errhandle/errcatch-function
+source /a/bin/errhandle/bash-trace-function
 
+errcatch
 
-sysv() {
-    echo "$@"
+m() {
+    echo "$*"
     "$@"
 }
-
-
-#
+s() { sudo "$@"; }
+lnf() { /a/exe/lnf "$@"; }
 
 
 shopt -s nullglob
 shopt -s extglob # note, already set with bash -l
 
-# if we make a link back to the root, traversing the subdirs stops.
-# This makes it so we can do subdir directories. Must call with absolute
-# paths.
+# If we make a link back to the root, we stop going deeper into subdir_files.
+# This makes it so we can do subdir directories.
+#
+# Also note, under filesystem/, symlinks are expanded.
 
 subdir-link-r() {
     local root="$1"
@@ -35,40 +36,68 @@ subdir-link-r() {
         local fullpath="$(readlink -f "$path")"
         #e $fullpath $below # debug
         if [[ -f $path || $(dirname $(readlink -f "$fullpath")) == "$below" ]]; then
-            sysv lnf -T "$path" "$HOME/${path#$root/}"
+            m lnf -T "$path" "$HOME/${path#$root/}"
         elif [[ -d "$path" ]]; then
             subdir-link-r "$root" "$path"
         fi
     done
 }
 
+
+
 common-file-setup() {
-    local dir fs_files x
+    local dir fs x bdir f dst
     for dir in "$@"; do
-        fs_files=( $dir/filesystem/* )
-        if [[ -e ${fs_files[0]} && $USER == ian ]]; then
+        fs=$dir/filesystem
+        if [[ -e $fs && $USER =~ ^iank?$ ]]; then
             # note, symlinks get resolved, not copied.
-            sysv s cp -RL ${fs_files[@]} /
+            s tar --mode=g-s --owner=0 --group=0 -cz -C $fs . | s tar -xz -C /
         fi
+
         if [[ -e $dir/subdir_files ]]; then
-            subdir-link-r $dir/subdir_files
+            subdir-link-r $dir/subdir_files
         fi
-        local x=( $dir/!(subdir_files|filesystem|machine_specific) )
+        local x=( $dir/!(binds|subdir_files|filesystem|machine_specific|..|.) )
         (( ${#x[@]} >= 1 )) || continue
-        sysv lnf ${x[@]} ~
+        m lnf ${x[@]} ~
     done
 }
 
 all_dirs=({/a/c,/p/c}{,/machine_specific/$HOSTNAME})
+# note, we assume a group of hosts does not have the
+# same name as a single host, which is no problem on our scale.
+for x in /p/c/machine_specific/*.hosts; do
+    if grep -qxF $HOSTNAME $x; then all_dirs+=( ${x%.hosts} ); fi
+done
+
 c_dirs=(/a/c{,/machine_specific/$HOSTNAME})
 case $USER in
-    ian)
+    ian|iank)
         # p needs to go first so .ssh link is created, then config link inside it
-        common-file-setup ${all_dirs[@]}
-        sudo -u traci "$BASH_SOURCE"
+        m common-file-setup ${all_dirs[@]}
+
+        #### begin special extra stuff ####
+        install -d -m700 ~/gpg-agent-socket
+        if [[ -d /etc/bind/bind-writable ]]; then
+            # need bind writable dir for nsupdate, or else we get
+            # named[20823]: /etc/bind/db.iank.pw.jnl: create: permission denied
+            m s chgrp bind /etc/bind/bind-writable
+        fi
+        files=(/etc/bind/[Kk]*)
+        if [[ -e $files ]]; then
+            m s chgrp bind ${files[@]}
+        fi
+        if [[ -e /etc/davpass ]] && getent group www-data &>/dev/null; then
+            s chgrp www-data /etc/davpass
+        fi
+        ##### end special extra stuff #####
+
+
+
+        m sudo -H -u traci "$BASH_SOURCE"
         ;;
     traci)
-        common-file-setup ${c_dirs[@]}
+        common-file-setup ${c_dirs[@]}
         ;;
     *)
         echo "$0: error: unexpected user"; exit 1